{$APPTYPE CONSOLE}
program Legions.Bot;
uses SysUtils, Math;
const
  MAX_SIZE = 100;
  PLAYER_NAME = 'delphi simple sample';
type
  TPoint = record
    x: Integer;
    y: Integer;
  end;
  
  TCell = record
    owner: Integer;
    isVeteran: Boolean;
    isConnected: Boolean;
  end;

  TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
  me: Integer;
  size: Integer;
  map: TMap;
  legionsCount: Integer;

procedure InputData();
var
  x, y: Integer;
  c1, c2: char;
begin
  legionsCount := 5;
  Readln(me);
  Readln(size);
  Readln;
  Readln;
  for y := 0 to size-1 do
  begin
    for x := 0 to size - 1 do
    begin
      Read(c1);
      Read(c2);
      if (c1 <> '.') then
      begin
        map[x][y].isVeteran := c1 in ['V', 'v'];
        map[x][y].isConnected := c1 in ['N', 'V'];
        map[x][y].owner := StrToInt(c2);
        Read(c2);
      end
      else
      begin
        map[x][y].isVeteran := false;
        map[x][y].isConnected := false;
        map[x][y].owner := -1;
      end
    end;
    Readln;
  end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
  if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
  else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
begin
  if map[x][y].owner = me then result := false
  else if (map[x][y].owner >= 0) and (legionsCount < 2) then result := false
  else if (map[x][y].owner >= 0) and (map[x][y].isVeteran) and (legionsCount < 3) then
    result := false
  else
    result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
           or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure MoveTo(x, y: Integer);
var
  c: Integer;
begin
  if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
  else if map[x][y].isVeteran then c := 3
  else c := 2;
  if (legionsCount >= c) then
  begin
    map[x][y].owner := me;
    map[x][y].isVeteran := c > 1;
    map[x][y].isConnected := true;
  end;
  Writeln(x, ' ', y, ' ', Min(legionsCount, c));
  Dec(legionsCount, c);
end;

procedure Move();
var
  x, y: Integer;
  bx, by: array[0..MAX_SIZE*MAX_SIZE] of Integer;
  ind, bcount: Integer;
begin
  while (legionsCount > 0) do
  begin
    bcount := 0;
    for y := 0 to size-1 do
      for x := 0 to size-1 do
      begin
        if CanMoveTo(x, y)then
        begin
          bx[bcount] := x;
          by[bcount] := y;
          Inc(bcount);
        end
      end;
      if (bcount > 0) then
      begin
        ind := Random(bcount);
        MoveTo(bx[ind], by[ind]);
      end
      else
        Exit;
    end;
end;

begin
  Randomize();
  if SeekEOF then
    Writeln(PLAYER_NAME)
  else
  begin
    InputData();
    Move();
  end;
end.
